## gammaray 2.11.0

=== CMakeLists.txt ===
# This is the top-level CMakeLists.txt file for the GammaRay project.
#
# Pass the following variables to cmake to control the build:
# (See Install.txt for more information)
#
# -DGAMMARAY_BUILD_UI=[true|false]
#  Build the client and in-process UI.
#  Default=true (except on QNX and Android)
#
# -DGAMMARAY_PROBE_ONLY_BUILD=[true|false]
#  Build only an additional probe configuration for an already existing launcher.
#  Default=false
#
# -DGAMMARAY_CLIENT_ONLY_BUILD=[true|false]
#  Build the client part only.
#  Default=false
#
# -DGAMMARAY_ENABLE_GPL_ONLY_FEATURES=[true|false]
#  Enable features only available under GPL license.
#  Default=false
#
# -DGAMMARAY_INSTALL_QT_LAYOUT=[true|false]
#  Install GammaRay in Qt folder using Qt layout folders:
#    - plugins will go in <qt_folder>/plugins/gammaray
#    - all the other libs, including probe library will go in <qt_folder>/lib
#    - qmake mkspecs file
#  Default=false
#  Only use for Android or when you know what you are doing.
#
# -DGAMMARAY_BUILD_CLI_INJECTOR=[true|false]
#  Build the cli injector on Windows
#  Default=true
#
# -DGAMMARAY_MULTI_BUILD=[true|false]
#  Build multiple applicable probe configurations.
#  Default=true
#
# -DGAMMARAY_STATIC_PROBE=[true|false]
#  Build the probe as static library for compile-time injection
#  Default=false
#
# -DGAMMARAY_BUILD_DOCS=[true|false]
#  Build the API documentation and User Manual.
#  Default=true (except when building the probe only)

# -DGAMMARAY_ENFORCE_QT_ASSERTS=[true|false]
#  Force QT_ASSERT in all builds.
#  Default=false
#
# To build the man page from POD, run 'make man' after CMake (assumes perl is available)
# To install the resulting man page, run 'make install'
# The man page is not available on Windows.
#

cmake_minimum_required(VERSION 3.1.0)

cmake_policy(SET CMP0020 NEW)
cmake_policy(SET CMP0043 NEW)
if(POLICY CMP0053)
  cmake_policy(SET CMP0053 NEW)
endif()
if(POLICY CMP0063)
  cmake_policy(SET CMP0063 NEW)
endif()
if(POLICY CMP0068)
  cmake_policy(SET CMP0068 NEW)
endif()

project(GammaRay CXX C)

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/ ${CMAKE_MODULE_PATH})
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
if(NOT DEFINED CMAKE_SKIP_BUILD_RPATH)
  set(CMAKE_SKIP_BUILD_RPATH ON)
endif()
if(NOT DEFINED CMAKE_BUILD_WITH_INSTALL_RPATH)
  set(CMAKE_BUILD_WITH_INSTALL_RPATH ON)
endif()
if(NOT DEFINED CMAKE_INSTALL_RPATH_USE_LINK_PATH)
  set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)
endif()
if(NOT DEFINED CMAKE_MACOSX_RPATH)
  set(CMAKE_MACOSX_RPATH TRUE)
endif()

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
endif()

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckCXXSymbolExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckSymbolExists)
include(CMakeParseArguments)
include(CMakePushCheckState)
include(CTest)
include(GammaRayMacros)
include(GammaRayMacrosInternal)
include(FeatureSummary)
set(KDE_INSTALL_USE_QT_SYS_PATHS OFF)
include(ECMGeneratePriFile)
include(ECMEnableSanitizers)
include(GenerateExportHeader)
include("3rdparty/backward-cpp/BackwardMacros.cmake")

# Exit for blacklisted compilers (those that don't support C++11 very well)
#  MSVC++ < 2013 aka 1800
#  Clang 3.1
set(BAD_CXX_MESSAGE "")
if(MSVC)
  if(MSVC_VERSION LESS 1800)
    set(BAD_CXX_MESSAGE "MSVC 2013 or higher")
  endif()
endif()
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  if(CMAKE_CXX_COMPILER_VERSION VERSION_LESS 3.1.0)
    set(BAD_CXX_MESSAGE "Clang v3.1.0 or higher")
  endif()
endif()
if(BAD_CXX_MESSAGE)
  message(FATAL_ERROR "\nSorry, ${BAD_CXX_MESSAGE} is required to build this software. Please retry using a modern compiler that supports C++11.")
endif()

if(MSVC AND MSVC_VERSION VERSION_EQUAL 1800)
  # MSVC 2013 implements some C++11 features only partially, which is why cmake
  # doesn't list these features as supported, still support is good enough for us.
  set(GAMMARAY_REQUIRED_CXX_FEATURES
            cxx_lambdas cxx_nullptr cxx_range_for cxx_raw_string_literals cxx_uniform_initialization
            cxx_variadic_templates cxx_rvalue_references cxx_defaulted_functions
            cxx_override cxx_final
  )
else()
  set(GAMMARAY_REQUIRED_CXX_FEATURES
            cxx_lambdas cxx_nullptr cxx_range_for cxx_raw_string_literals cxx_uniform_initialization
            cxx_variadic_templates cxx_rvalue_references cxx_defaulted_functions cxx_deleted_functions
            cxx_override cxx_final cxx_nonstatic_member_init
  )
endif()

# Version setup
set(GAMMARAY_VERSION_MAJOR "2")
set(GAMMARAY_VERSION_MINOR "11")
set(GAMMARAY_VERSION_PATCH "0")
set(GAMMARAY_VERSION "${GAMMARAY_VERSION_MAJOR}.${GAMMARAY_VERSION_MINOR}.${GAMMARAY_VERSION_PATCH}")
set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION}")
set(GAMMARAY_SOVERSION "2.11.0")
set(GAMMARAY_PLUGIN_VERSION "2.11")
set(PROJECT_VERSION_STRING "${GAMMARAY_VERSION_STRING}")
if(ANDROID)
  # non-rooted Android doesn't like .so versions and requires the lib prefix
  set(GAMMARAY_DEFAULT_LIBRARY_PROPERTIES PREFIX "lib")
else()
  set(GAMMARAY_DEFAULT_LIBRARY_PROPERTIES SOVERSION ${GAMMARAY_SOVERSION} VERSION ${GAMMARAY_SOVERSION})
endif()

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
  find_package(Git)
  set_package_properties(Git PROPERTIES TYPE OPTIONAL PURPOSE "Determine exact build version.")
  if(GIT_FOUND)
    execute_process(
      COMMAND ${GIT_EXECUTABLE} rev-parse --short HEAD
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      OUTPUT_VARIABLE _git_revision
    )
    string(REGEX REPLACE "\n" "" _git_revision "${_git_revision}")
    set(GAMMARAY_VERSION_STRING "${GAMMARAY_VERSION_STRING} (revision: ${_git_revision})")
  endif()
endif()

configure_file(
  ${CMAKE_CURRENT_SOURCE_DIR}/config-gammaray-version.h.cmake
  ${CMAKE_CURRENT_BINARY_DIR}/config-gammaray-version.h
)

message(STATUS "Building GammaRay ${GAMMARAY_VERSION_STRING} in ${CMAKE_BUILD_TYPE} mode")

#
# Build options
#
set(GAMMARAY_BUILD_UI_DEFAULT ON)
if(QNXNTO OR ANDROID)
  set(GAMMARAY_BUILD_UI_DEFAULT OFF)
endif()

gammaray_option(
  GAMMARAY_PROBE_ONLY_BUILD
  "Build only an additional probe configuration for an already existing launcher."
  OFF
)

gammaray_option(
  GAMMARAY_CLIENT_ONLY_BUILD
  "Build the client part only."
  OFF
)

if(GAMMARAY_CLIENT_ONLY_BUILD)
  set(GAMMARAY_BUILD_UI_DEFAULT ON)
endif()

gammaray_option(GAMMARAY_BUILD_UI "Build the GammaRay client and in-process UI." ${GAMMARAY_BUILD_UI_DEFAULT})

if(GAMMARAY_PROBE_ONLY_BUILD AND GAMMARAY_CLIENT_ONLY_BUILD)
  message(FATAL_ERROR "You can only use one of the *ONLY* option.")
endif()

gammaray_option(GAMMARAY_ENABLE_GPL_ONLY_FEATURES "Enable features only available under GPL license." OFF)
gammaray_option(GAMMARAY_INSTALL_QT_LAYOUT "Install into Qt directory layout." OFF)
gammaray_option(GAMMARAY_MULTI_BUILD "Build multiple applicable probe configurations." ON)
gammaray_option(GAMMARAY_BUILD_CLI_INJECTOR "Build command line injector on Windows." ON)

set(GAMMARAY_BUILD_DOCS_DEFAULT ON)
set(GAMMARAY_DISABLE_FEEDBACK_DEFAULT OFF)
if(GAMMARAY_PROBE_ONLY_BUILD OR CMAKE_CROSSCOMPILING)
  set(GAMMARAY_BUILD_DOCS_DEFAULT OFF)
  set(GAMMARAY_DISABLE_FEEDBACK_DEFAULT ON)
endif()
gammaray_option(GAMMARAY_BUILD_DOCS "Build GammaRay documentation." ${GAMMARAY_BUILD_DOCS_DEFAULT})
gammaray_option(
  GAMMARAY_STATIC_PROBE
  "Build the probe as static library for compile-time injection."
  OFF
)

gammaray_option(
  GAMMARAY_ENFORCE_QT_ASSERTS
  "Force QT_ASSERT in all builds."
  OFF
)

gammaray_option(GAMMARAY_DISABLE_FEEDBACK "Disable user feedback support." ${GAMMARAY_DISABLE_FEEDBACK_DEFAULT})

#
# Static probe setup
#
if(GAMMARAY_STATIC_PROBE)
  set(GAMMARAY_BUILD_UI OFF)
  set(GAMMARAY_PROBE_ONLY_BUILD ON)

  set(GAMMARAY_LIBRARY_TYPE STATIC)
  set(GAMMARAY_PLUGIN_TYPE STATIC)
else()
  set(GAMMARAY_LIBRARY_TYPE SHARED)
  set(GAMMARAY_PLUGIN_TYPE MODULE)
endif()

#
# Compiler & linker settings
#
function(append_if condition value)
  if(${condition})
    foreach(variable ${ARGN})
      set(${variable} "${${variable}} ${value}" PARENT_SCOPE)
    endforeach()
  endif()
endfunction()

macro(add_flag_if_supported flag name)
  check_c_compiler_flag("-Werror ${flag}" "C_SUPPORTS_${name}")
  append_if("C_SUPPORTS_${name}" "${flag}" CMAKE_C_FLAGS)
  check_cxx_compiler_flag("-Werror ${flag}" "CXX_SUPPORTS_${name}")
  append_if("CXX_SUPPORTS_${name}" "${flag}" CMAKE_CXX_FLAGS)
endmacro()

function(check_private_headers_exist module)
  message(STATUS "Checking whether private include directories for module ${module} exist")
  # backward compatibility with Qt < 5.9
  if (TARGET Qt5::${module}Private)
    get_target_property(private_includes Qt5::${module}Private INTERFACE_INCLUDE_DIRECTORIES)
    set(Qt5${module}_PRIVATE_INCLUDE_DIRS "${private_includes}" PARENT_SCOPE)
  endif()

  # HACK to work around broken Qt cmake configurations in older Qt version (up to 5.7 at least)
  if(NOT "${Qt5${module}_PRIVATE_INCLUDE_DIRS}" MATCHES "/Qt${module}/")
    string(REPLACE "/QtCore" "/Qt${module}" replaceme "${Qt5Core_PRIVATE_INCLUDE_DIRS}")
    list(APPEND Qt5${module}_PRIVATE_INCLUDE_DIRS ${replaceme})
    list(REMOVE_DUPLICATES Qt5${module}_PRIVATE_INCLUDE_DIRS)
    set(Qt5${module}_PRIVATE_INCLUDE_DIRS ${Qt5${module}_PRIVATE_INCLUDE_DIRS} PARENT_SCOPE)
  endif()

  foreach(dir ${Qt5${module}_PRIVATE_INCLUDE_DIRS})
    if(NOT EXISTS "${dir}")
      message(FATAL_ERROR "The private include directory ${dir} for module ${module} do not exist! Please make sure your Qt5 installation contains private headers.\nThe required directories:\n  ${Qt5${module}_PRIVATE_INCLUDE_DIRS}")
    endif()
  endforeach()
endfunction()

function(check_private_header_exists module file)
  set(found FALSE)
  foreach(dir ${Qt5${module}_PRIVATE_INCLUDE_DIRS})
    if(EXISTS "${dir}/${file}")
      set(found TRUE)
    endif()
  endforeach()
  if(NOT found)
    message(FATAL_ERROR "The private include file ${file} was not found in directory ${Qt5${module}_PRIVATE_INCLUDE_DIRS}! Please make sure your Qt5 installation contains private headers.")
  endif()
endfunction()

set(CMAKE_CXX_VISIBILITY_PRESET hidden)
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_flag_if_supported(-Wunused-but-set-variable UNUSED_BUT_SET)
  add_flag_if_supported(-Wlogical-op LOGICAL_OP)
  add_flag_if_supported(-Wsizeof-pointer-memaccess POINTER_MEMACCESS)
  add_flag_if_supported(-Wreorder REORDER)
  add_flag_if_supported(-Wformat-security FORMAT_SECURITY)

  check_cxx_compiler_flag(-std=gnu++0x HAVE_GXX_GNUXX11)
  check_cxx_compiler_flag(-std=c++0x HAVE_GXX_CXX11)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -Wextra -pedantic -Woverloaded-virtual -Winit-self -Wmissing-include-dirs -Wunused -Wundef -Wpointer-arith -Wmissing-noreturn -Werror=return-type -Wswitch")
  if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
    # -Wgnu-zero-variadic-macro-arguments (part of -pedantic) is triggered by every qCDebug() call and therefore results
    # in a lot of noise. This warning is only notifying us that clang is emulating the GCC behaviour
    # instead of the exact standard wording so we can safely ignore it
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-gnu-zero-variadic-macro-arguments")
  endif()
  if(HAVE_GXX_GNUXX11) # QNX needs gnu++0x rather than c++0x for compiling QML V4 private headers
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++0x")
  elseif(HAVE_GXX_CXX11)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
  endif()
  if(MINGW)
    # mingw will error out on the crazy casts in probe.cpp without this
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fpermissive")
  endif()
endif()
if(CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Qunused-arguments -Wdocumentation")
endif()
if(CMAKE_C_COMPILER_ID MATCHES "Clang")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Qunused-arguments -Wdocumentation")
endif()

=== app/CMakeLists.txt ===
# Integrated launcher/client for Mac app bundles
if(APPLE)
  if(NOT GAMMARAY_INSTALL_QT_LAYOUT)
    # CMake does not allow to have a bundle executable having a name different then the bundle folder name...
    # So we are disabling the bundle behavior here and generate a standard binary
    # The bundle structure will be auto created from the different INSTALL_XXX variables and we only manually generate
    # the Info.plist file

    set(gammaray_app_srcs main.cpp)

    add_executable(gammaray-app ${gammaray_app_srcs})

    target_link_libraries(gammaray-app
      Qt5::Gui Qt5::Widgets
      gammaray_common
      gammaray_launcher
      gammaray_launcher_ui
      gammaray_client
    )

    set_target_properties(gammaray-app PROPERTIES
      OUTPUT_NAME "GammaRayUI"
      INSTALL_RPATH "@executable_path/../Frameworks"
    )

    # Let generate our Info.plist file...
    set(GAMMARAY_BUNDLE_INFO_PLIST_IN "${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in")
    set(GAMMARAY_BUNDLE_INFO_PLIST_OUT "${PROJECT_BINARY_DIR}/${BUNDLE_INSTALL_DIR}/${BUNDLE_APP_NAME}/Contents/Info.plist")

    set(GAMMARAY_BUNDLE_GUI_IDENTIFIER "com.kdab.gammaray")
    set(GAMMARAY_BUNDLE_EXECUTABLE "GammaRayUI")
    set(GAMMARAY_BUNDLE_BUNDLE_NAME "GammaRay")
    set(GAMMARAY_BUNDLE_ICON_FILE "GammaRay.icns")
    set(GAMMARAY_BUNDLE_BUNDLE_VERSION "${GAMMARAY_VERSION}")
    set(GAMMARAY_BUNDLE_SHORT_VERSION_STRING "${GAMMARAY_VERSION}")
    set(GAMMARAY_BUNDLE_LONG_VERSION_STRING "${GAMMARAY_VERSION_STRING}")
    set(GAMMARAY_BUNDLE_INFO_STRING "GammaRay ${GAMMARAY_VERSION}")
    set(GAMMARAY_BUNDLE_COPYRIGHT "Copyright (C) 2010-2019 Klarälvdalens Datakonsult AB, a KDAB Group company, info@kdab.com")

    configure_file("${GAMMARAY_BUNDLE_INFO_PLIST_IN}" "${GAMMARAY_BUNDLE_INFO_PLIST_OUT}")

    # Install stuff
    install(TARGETS gammaray-app ${INSTALL_TARGETS_DEFAULT_ARGS})
    install(FILES "${GAMMARAY_BUNDLE_INFO_PLIST_OUT}" DESTINATION "${BUNDLE_INSTALL_DIR}/${BUNDLE_APP_NAME}/Contents")
  endif()
endif()

=== core/CMakeLists.txt ===
set(gammaray_srcs
  ${CMAKE_SOURCE_DIR}/3rdparty/qt/resourcemodel.cpp

  abstractbindingprovider.cpp
  aggregatedpropertymodel.cpp
  bindingaggregator.cpp
  bindingnode.cpp
  metaobject.cpp
  metaobjectregistry.cpp
  metaobjectrepository.cpp
  metaproperty.cpp
  probe.cpp
  probeguard.cpp
  probesettings.cpp
  probecontroller.cpp
  objectlistmodel.cpp
  objectclassinfomodel.cpp
  objectmethodmodel.cpp
  objectenummodel.cpp
  objecttreemodel.cpp
  objecttypefilterproxymodel.cpp
  problemcollector.cpp
  methodargumentmodel.cpp
  multisignalmapper.cpp
  signalspycallbackset.cpp
  singlecolumnobjectproxymodel.cpp
  stacktracemodel.cpp
  toolfactory.cpp
  toolmanager.cpp
  toolpluginmodel.cpp
  toolpluginerrormodel.cpp
  propertycontroller.cpp
  propertycontrollerextension.cpp
  proxytoolfactory.cpp
  util.cpp
  varianthandler.cpp
  objectdataprovider.cpp
  attributemodel.cpp
  qmetaobjectvalidator.cpp
  enumrepositoryserver.cpp
  enumutil.cpp
  execution.cpp
  classesiconsrepositoryserver.cpp

  propertyadaptor.cpp
  propertyaggregator.cpp
  propertydata.cpp
  propertyfilter.cpp
  dynamicpropertyadaptor.cpp
  qmetapropertyadaptor.cpp
  metapropertyadaptor.cpp
  associativepropertyadaptor.cpp
  sequentialpropertyadaptor.cpp
  objectinstance.cpp
  propertyadaptorfactory.cpp
  jsonpropertyadaptor.cpp

  paintbuffer.cpp
  paintbuffermodel.cpp
  paintanalyzer.cpp
  painterprofilingreplayer.cpp

  remoteviewserver.cpp

  tools/metatypebrowser/metatypesmodel.cpp
  tools/messagehandler/messagehandler.cpp
  tools/messagehandler/messagemodel.cpp
  tools/metaobjectbrowser/metaobjectbrowser.cpp
  tools/metaobjectbrowser/metaobjecttreemodel.cpp
  tools/metatypebrowser/metatypebrowser.cpp
  tools/objectinspector/objectinspector.cpp
  tools/objectinspector/propertiesextension.cpp
  tools/objectinspector/methodsextension.cpp
  tools/objectinspector/connectionsextension.cpp
  tools/objectinspector/abstractconnectionsmodel.cpp
  tools/objectinspector/inboundconnectionsmodel.cpp
  tools/objectinspector/outboundconnectionsmodel.cpp
  tools/objectinspector/enumsextension.cpp
  tools/objectinspector/classinfoextension.cpp
  tools/objectinspector/applicationattributeextension.cpp
  tools/objectinspector/bindingextension.cpp
  tools/objectinspector/bindingmodel.cpp
  tools/objectinspector/stacktraceextension.cpp
  tools/problemreporter/availablecheckersmodel.cpp
  tools/problemreporter/problemmodel.cpp
  tools/problemreporter/problemreporter.cpp
  tools/resourcebrowser/resourcebrowser.cpp
  tools/resourcebrowser/resourcefiltermodel.cpp

  remote/server.cpp
  remote/remotemodelserver.cpp
  remote/selectionmodelserver.cpp
  remote/serverdevice.cpp
  remote/tcpserverdevice.cpp
  remote/localserverdevice.cpp
  remote/serverproxymodel.cpp

  ${CMAKE_SOURCE_DIR}/resources/gammaray.qrc
)

set(gammaray_srcs
  ${gammaray_srcs}
  tools/messagehandler/loggingcategorymodel.cpp
)

include_directories(${CMAKE_SOURCE_DIR}/3rdparty/qt/5.5/)
list(APPEND gammaray_srcs ${CMAKE_SOURCE_DIR}/3rdparty/qt/5.5/private/qpaintbuffer.cpp)

if(WIN32 AND NOT MINGW)
  list(APPEND gammaray_srcs ${CMAKE_SOURCE_DIR}/3rdparty/StackWalker/StackWalker.cpp)
endif()

# core lib
add_library(gammaray_core ${GAMMARAY_LIBRARY_TYPE}
  ${gammaray_srcs}
)
generate_export_header(gammaray_core)
target_compile_features(gammaray_core PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})

gammaray_target_relocatable_interfaces(gammaray_core_ipaths)
target_include_directories(gammaray_core PUBLIC $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}> $<INSTALL_INTERFACE:${gammaray_core_ipaths}>)
target_include_directories(gammaray_core SYSTEM PRIVATE
    ${CMAKE_SOURCE_DIR}/3rdparty/backward-cpp
    ${Qt5Core_PRIVATE_INCLUDE_DIRS}
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
)
target_link_libraries(gammaray_core
  LINK_PUBLIC gammaray_common
  LINK_PRIVATE gammaray_common_internal gammaray_kitemmodels ${CMAKE_DL_LIBS}
)
set_target_properties(gammaray_core PROPERTIES
  ${GAMMARAY_DEFAULT_LIBRARY_PROPERTIES}
  OUTPUT_NAME gammaray_core-${GAMMARAY_PROBE_ABI}
)
gammaray_set_rpath(gammaray_core ${LIB_INSTALL_DIR})

target_link_libraries(gammaray_core LINK_PUBLIC Qt5::Core LINK_PRIVATE Qt5::Gui)

add_backward(gammaray_core)

if(NOT GAMMARAY_PROBE_ONLY_BUILD)
  install(TARGETS gammaray_core EXPORT GammaRayTargets ${INSTALL_TARGETS_DEFAULT_ARGS})

  gammaray_install_headers(
    ${CMAKE_CURRENT_BINARY_DIR}/gammaray_core_export.h
    enumrepositoryserver.h
    enumutil.h
    metaobject.h
    metaobjectrepository.h
    metaproperty.h
    objectmodelbase.h
    objectdataprovider.h
    objecttypefilterproxymodel.h
    probe.h
    probecontroller.h
    propertycontroller.h
    propertycontrollerextension.h
    signalspycallbackset.h
    singlecolumnobjectproxymodel.h
    toolfactory.h
    typetraits.h
    util.h
    varianthandler.h
  )

  ecm_generate_pri_file(BASE_NAME GammaRayCore
                        LIB_NAME gammaray_core-${GAMMARAY_PROBE_ABI}
                        DEPS "core gui GammaRayCommon"
                        FILENAME_VAR PRI_FILENAME
                        INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR}
  )

  install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})
  if(GAMMARAY_STATIC_PROBE)
    gammaray_install_headers(staticprobe.h)
  endif()
else()
  install(TARGETS gammaray_core ${INSTALL_TARGETS_DEFAULT_ARGS})
endif()
if(MSVC)
  install(FILES "$<TARGET_PDB_FILE_DIR:gammaray_core>/$<TARGET_PDB_FILE_NAME:gammaray_core>" DESTINATION ${BIN_INSTALL_DIR} CONFIGURATIONS Debug RelWithDebInfo)
endif()

=== docs/CMakeLists.txt ===
#
# find doc generation tools needed by multiple sub-directories
#

# qdoc toolchain
# TODO: some of this probably should be upstreamed to Qt's cmake files...
# TODO replace with Qt5::qhelpgenerator for Qt >= 5.7.1
find_program(QHELPGEN_EXECUTABLE qhelpgenerator
  HINTS ${QT_INSTALL_BINS}
)
find_program(QDOC_EXECUTABLE qdoc
  HINTS ${QT_INSTALL_BINS}
)
find_program(QTATTRIBUTIONSSCANNER_EXECUTABLE qtattributionsscanner
  HINTS ${QT_INSTALL_BINS}
)

find_file(QDOC_TEMPLATE global/qt-html-templates-offline.qdocconf
  HINTS ${QT_INSTALL_DOCS}
  HINTS ${QT_INSTALL_DATA}
  HINTS ${QT_INSTALL_DATA}/doc
)
find_file(QDOC_QTCORE_INDEX qtcore.index
  HINTS ${QT_INSTALL_DOCS}/qtcore
  HINTS ${QT_INSTALL_DATA}/doc/qtcore
)

if(NOT QDOC_EXECUTABLE OR NOT QHELPGEN_EXECUTABLE OR NOT QDOC_TEMPLATE OR NOT QDOC_QTCORE_INDEX OR NOT QTATTRIBUTIONSSCANNER_EXECUTABLE)
  message(STATUS "Unable to build user manual in qch format.")
  message(STATUS "qdoc exectuable: ${QDOC_EXECUTABLE}")
  message(STATUS "qhelpgenerator exectuable: ${QHELPGEN_EXECUTABLE}")
  message(STATUS "qtattributionsscanner executable: ${QTATTRIBUTIONSSCANNER_EXECUTABLE}")
  message(STATUS "qdoc template (qt-html-templates-offline.qdocconf): ${QDOC_TEMPLATE}")
  message(STATUS "qdoc qtcore index (qtcore.index): ${QDOC_QTCORE_INDEX}")
  set(GAMMARAY_USER_MANUAL_BUILD False)
else()
  set(GAMMARAY_USER_MANUAL_BUILD True)
endif()

add_feature_info("User Manual creation in qch format" GAMMARAY_USER_MANUAL_BUILD "Requires qdoc, qhelpgenerator, qtattributionsscanner, the qdoc templates and index files")

# Doxygen
find_package(Doxygen)
set_package_properties(Doxygen PROPERTIES
  TYPE OPTIONAL
  DESCRIPTION "API Documentation system"
  URL "http://www.doxygen.org"
  PURPOSE "Needed to build the API documentation."
)
if(DOXYGEN_DOT_EXECUTABLE)
  set(HAVE_DOT "YES")
else()
  set(HAVE_DOT "NO")
  message(STATUS "Unable to provide inheritance diagrams for the API documentation. To fix, install the graphviz project from http://www.graphviz.org")
endif()

if(DOXYGEN_FOUND AND QHELPGEN_EXECUTABLE)
  set(GAMMARAY_API_DOCS_BUILD True)
else()
  set(GAMMARAY_API_DOCS_BUILD False)
endif()

#
# generate docs
#

if(GAMMARAY_API_DOCS_BUILD)
  add_subdirectory(api)
endif()
if(GAMMARAY_USER_MANUAL_BUILD)
  add_subdirectory(manual)
  add_subdirectory(collection)
endif()
add_subdirectory(man)

=== multibuild/CMakeLists.txt ===
include(ExternalProject)

# on Windows we need to build the debug/release counter-part as well
if(NOT WIN32)
  return()
endif()

if(CMAKE_BUILD_TYPE MATCHES "^[Rr]el")
  set(_build_type "Debug")
else()
  set(_build_type "Release")
endif()

ExternalProject_Add(
  GammaRay-${_build_type}
  SOURCE_DIR ${CMAKE_SOURCE_DIR}
  BINARY_DIR ${CMAKE_CURRENT_BINARY_DIR}/GammaRay-${_build_type}
  EXCLUDE_FROM_ALL 1
  STEP_TARGETS build install

  CMAKE_ARGS
    -DCMAKE_BUILD_TYPE=${_build_type}
    -DGAMMARAY_MULTI_BUILD=OFF
    -DGAMMARAY_PROBE_ONLY_BUILD=ON
    -DGAMMARAY_BUILD_CLI_INJECTOR=OFF
    -DGAMMARAY_INSTALL_QT_LAYOUT=${GAMMARAY_INSTALL_QT_LAYOUT}
    -DGAMMARAY_BUILD_UI=${GAMMARAY_BUILD_UI}
    -DGAMMARAY_OUTPUT_PREFIX=${CMAKE_BINARY_DIR}
    -DCMAKE_INSTALL_PREFIX=${CMAKE_INSTALL_PREFIX}
    -DCMAKE_PREFIX_PATH=${CMAKE_PREFIX_PATH}
    -DBUILD_TESTING=OFF
)

# hacky way to add a dependency from the default target to the build step
add_custom_target(multibuild_build ALL DEPENDS GammaRay-${_build_type}-build)

# even hackier way to postpone external project installation to install time
add_custom_target(multibuild_install)
add_dependencies(multibuild_install GammaRay-${_build_type}-install)
_ep_get_step_stampfile(GammaRay-${_build_type} "install" install_stamp_file)
if(install_stamp_file)
    install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" -E remove \"${install_stamp_file}\")")
endif()
install(CODE "execute_process(COMMAND \"${CMAKE_COMMAND}\" --build \"${CMAKE_BINARY_DIR}\" --target multibuild_install)")

=== plugins/CMakeLists.txt ===
add_subdirectory(codecbrowser)
add_subdirectory(eventmonitor)
add_subdirectory(fontbrowser)
add_subdirectory(kjobtracker)
add_subdirectory(localeinspector)
add_subdirectory(modelinspector)
add_subdirectory(quickinspector)
add_subdirectory(signalmonitor)
add_subdirectory(statemachineviewer)
add_subdirectory(timertop)

add_subdirectory(mimetypes)
add_subdirectory(network)
add_subdirectory(objectvisualizer)
add_subdirectory(qtivi)
add_subdirectory(sysinfo)
add_subdirectory(translatorinspector)
add_subdirectory(webinspector)
add_subdirectory(wlcompositorinspector)


if(Qt5Gui_FOUND)
  add_subdirectory(guisupport)
  add_subdirectory(textdocumentinspector)
endif()

if(Qt5Widgets_FOUND)
  add_subdirectory(actioninspector)
  add_subdirectory(widgetinspector)
  add_subdirectory(sceneinspector)
  add_subdirectory(styleinspector)
endif()

# just checking whether Qt5::ScriptTools is found should be enough, but it isn't.
# thus check both that Qt5::Script & Qt5::ScriptTools are found to fix https://github.com/KDAB/GammaRay/issues/492
if((Qt5Script_FOUND AND Qt5ScriptTools_FOUND) OR (Qt5Script_FOUND AND Qt5ScriptTools_FOUND))
  add_subdirectory(scriptenginedebugger)
endif()

if(Qt5Qml_FOUND)
  add_subdirectory(qmlsupport)
endif()

if(Qt5QuickWidgets_FOUND)
  add_subdirectory(quickwidgetsupport)
endif()

if(Qt5Bluetooth_FOUND)
  add_subdirectory(bluetooth)
endif()

if(Qt5Positioning_FOUND)
  add_subdirectory(positioning)
endif()

if(Qt53DRender_FOUND AND Qt53DExtras_FOUND)
  add_subdirectory(qt3dinspector)
endif()

=== probe/CMakeLists.txt ===
if (NOT GAMMARAY_CLIENT_ONLY_BUILD)
set(gammaray_probe_srcs
  probecreator.cpp
  hooks.cpp
)

list(APPEND gammaray_probe_srcs entry_unix.cpp)

# create intermediate gammaray_probe object files which unit tests can use
add_library(gammaray_probe_obj OBJECT ${gammaray_probe_srcs})
set_target_properties(gammaray_probe_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(gammaray_probe_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
target_compile_definitions(gammaray_probe_obj PRIVATE ${Qt5Core_DEFINITIONS}) # for -DQT_NAMESPACE=...
target_include_directories(gammaray_probe_obj PUBLIC
    $<TARGET_PROPERTY:gammaray_core,INTERFACE_INCLUDE_DIRECTORIES>
    $<TARGET_PROPERTY:gammaray_common,INTERFACE_INCLUDE_DIRECTORIES>
)
target_include_directories(gammaray_probe_obj SYSTEM PRIVATE ${Qt5Core_PRIVATE_INCLUDE_DIRS})

# probe lib
# DYLD_INSERT_LIBRARIES only works with real shared libraries, not modules
# Windows also needs SHARED rather than MODULE here, to end up in bin/
add_library(gammaray_probe ${GAMMARAY_LIBRARY_TYPE} $<TARGET_OBJECTS:gammaray_probe_obj>)
target_link_libraries(gammaray_probe gammaray_core ${CMAKE_DL_LIBS})

set_target_properties(gammaray_probe PROPERTIES
  LIBRARY_OUTPUT_DIRECTORY "${GAMMARAY_OUTPUT_PREFIX}/${PROBE_INSTALL_DIR}"
  RUNTIME_OUTPUT_DIRECTORY "${GAMMARAY_OUTPUT_PREFIX}/${PROBE_INSTALL_DIR}"
)
target_compile_features(gammaray_probe PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})

if(WIN32)
  add_library(gammaray_winloader SHARED entry_win.cpp)
  set_target_properties(gammaray_winloader PROPERTIES
    LIBRARY_OUTPUT_DIRECTORY "${GAMMARAY_OUTPUT_PREFIX}/${PROBE_INSTALL_DIR}"
    RUNTIME_OUTPUT_DIRECTORY "${GAMMARAY_OUTPUT_PREFIX}/${PROBE_INSTALL_DIR}"
  )
    target_compile_features(gammaray_winloader PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
endif()

if(NOT GAMMARAY_INSTALL_QT_LAYOUT)
  set_target_properties(gammaray_probe PROPERTIES PREFIX "")
  gammaray_set_rpath(gammaray_probe ${PROBE_INSTALL_DIR})
  install(TARGETS gammaray_probe DESTINATION ${PROBE_INSTALL_DIR})
  if(WIN32)
    set_target_properties(gammaray_winloader PROPERTIES PREFIX "")
    install(TARGETS gammaray_winloader DESTINATION ${PROBE_INSTALL_DIR})
  endif()
else()
  set_target_properties(gammaray_probe PROPERTIES OUTPUT_NAME gammaray_probe-${GAMMARAY_PROBE_ABI})
  gammaray_set_rpath(gammaray_probe ${LIB_INSTALL_DIR})
  if(WIN32)
    set_target_properties(gammaray_winloader PROPERTIES OUTPUT_NAME gammaray_winloader-${GAMMARAY_PROBE_ABI})
    install(TARGETS gammaray_winloader ${INSTALL_TARGETS_DEFAULT_ARGS})
  endif()
  if(NOT GAMMARAY_PROBE_ONLY_BUILD)
    install(TARGETS gammaray_probe EXPORT GammaRayTargets ${INSTALL_TARGETS_DEFAULT_ARGS})

    ecm_generate_pri_file(BASE_NAME GammaRayProbe
                        LIB_NAME gammaray_probe-${GAMMARAY_PROBE_ABI}
                        DEPS "core gui network GammaRayCommon GammaRayCore"
                        FILENAME_VAR PRI_FILENAME
                        INCLUDE_INSTALL_DIR ${INCLUDE_INSTALL_DIR})

    install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})
  else()
    install(TARGETS gammaray_probe ${INSTALL_TARGETS_DEFAULT_ARGS})
  endif()
  if (ANDROID)
    install(FILES gammaray_probe-android-dependencies.xml RENAME gammaray_probe-${GAMMARAY_PROBE_ABI}-android-dependencies.xml DESTINATION ${LIB_INSTALL_DIR})
  endif()
endif()

if(MSVC)
    install(FILES "$<TARGET_PDB_FILE_DIR:gammaray_probe>/$<TARGET_PDB_FILE_NAME:gammaray_probe>" DESTINATION ${BIN_INSTALL_DIR} CONFIGURATIONS Debug RelWithDebInfo)
endif()

endif() # GAMMARAY_CLIENT_ONLY_BUILD

=== tests/CMakeLists.txt ===
# keep test output locally, in the multibuild case
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR}/${LIB_INSTALL_DIR})

configure_file(gammaray-test-config.h.in ${CMAKE_CURRENT_BINARY_DIR}/gammaray-test-config.h)

# create intermediate modeltestobj object files which unit tests can use
add_library(modeltestobj OBJECT ${CMAKE_SOURCE_DIR}/3rdparty/qt/modeltest.cpp)
set_target_properties(modeltestobj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(modeltestobj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
target_compile_definitions(modeltestobj PRIVATE $<TARGET_PROPERTY:Qt5::Core,INTERFACE_COMPILE_DEFINITIONS>) # for -DQT_NAMESPACE=...
target_include_directories(modeltestobj PUBLIC $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES>)

# create intermediate test_helpers_obj object files which unit tests can use
add_library(test_helpers_obj OBJECT testhelpers.cpp)
set_target_properties(test_helpers_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(test_helpers_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
target_compile_definitions(test_helpers_obj PRIVATE
    $<TARGET_PROPERTY:Qt5::Core,INTERFACE_COMPILE_DEFINITIONS>
    $<TARGET_PROPERTY:Qt5::Test,INTERFACE_COMPILE_DEFINITIONS>
) # for -DQT_NAMESPACE=...
target_include_directories(test_helpers_obj PUBLIC
  $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES>
  $<TARGET_PROPERTY:Qt5::Test,INTERFACE_INCLUDE_DIRECTORIES>
)

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
# create intermediate base_probe_test_obj object files which unit tests can use
add_library(base_probe_test_obj OBJECT baseprobetest.h)
set_target_properties(base_probe_test_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
target_compile_features(base_probe_test_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
target_include_directories(base_probe_test_obj PUBLIC
  $<TARGET_PROPERTY:gammaray_core,INTERFACE_INCLUDE_DIRECTORIES>
  $<TARGET_PROPERTY:gammaray_common,INTERFACE_INCLUDE_DIRECTORIES>
)
target_compile_definitions(base_probe_test_obj PRIVATE
    $<TARGET_PROPERTY:Qt5::Core,INTERFACE_COMPILE_DEFINITIONS>
    $<TARGET_PROPERTY:Qt5::Test,INTERFACE_COMPILE_DEFINITIONS>
) # for -DQT_NAMESPACE=...
target_include_directories(base_probe_test_obj PUBLIC
  $<TARGET_PROPERTY:Qt5::Core,INTERFACE_INCLUDE_DIRECTORIES>
  $<TARGET_PROPERTY:Qt5::Test,INTERFACE_INCLUDE_DIRECTORIES>
)

if(Qt5Quick_FOUND)
  # create intermediate base_quick_test_obj object files which unit tests can use
  add_library(base_quick_test_obj OBJECT basequicktest.h)
  set_target_properties(base_quick_test_obj PROPERTIES POSITION_INDEPENDENT_CODE ON)
  target_compile_features(base_quick_test_obj PUBLIC ${GAMMARAY_REQUIRED_CXX_FEATURES})
  target_compile_definitions(base_quick_test_obj PRIVATE
    $<TARGET_PROPERTY:Qt5::Core,INTERFACE_COMPILE_DEFINITIONS>
    $<TARGET_PROPERTY:Qt5::Test,INTERFACE_COMPILE_DEFINITIONS>
    $<TARGET_PROPERTY:Qt5::Quick,INTERFACE_COMPILE_DEFINITIONS>
  ) # for -DQT_NAMESPACE=...
  target_include_directories(base_quick_test_obj PUBLIC
    $<TARGET_PROPERTY:base_probe_test_obj,INTERFACE_INCLUDE_DIRECTORIES>
  )
  target_include_directories(base_quick_test_obj PUBLIC
    $<TARGET_PROPERTY:Qt5::Quick,INTERFACE_INCLUDE_DIRECTORIES>
  )
endif()
endif()

add_subdirectory(shared)
add_subdirectory(manual)
add_subdirectory(targets)

# plain unit tests
function(gammaray_add_test _name)
  add_executable(${_name} ${ARGN} $<TARGET_OBJECTS:test_helpers_obj>)
  gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
  target_link_libraries(${_name} Qt5::Test)
  add_test(NAME ${_name} COMMAND ${_name})
endfunction()

# unit tests requiring probe injection
function(gammaray_add_probe_test _name)
  add_executable(${_name} ${ARGN}
    $<TARGET_OBJECTS:gammaray_probe_obj>
    $<TARGET_OBJECTS:test_helpers_obj>
    $<TARGET_OBJECTS:base_probe_test_obj>
  )
  gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
  target_link_libraries(${_name} $<TARGET_PROPERTY:gammaray_probe,LINK_LIBRARIES> Qt5::Test)
  add_test(NAME ${_name} COMMAND ${_name})
endfunction()

# unit tests requiring quick and probe injection
function(gammaray_add_quick_test _name)
  add_executable(${_name} ${ARGN}
    $<TARGET_OBJECTS:gammaray_probe_obj>
    $<TARGET_OBJECTS:test_helpers_obj>
    $<TARGET_OBJECTS:base_probe_test_obj>
    $<TARGET_OBJECTS:base_quick_test_obj>
  )
  gammaray_set_rpath(${_name} ${BIN_INSTALL_DIR})
  target_link_libraries(${_name} $<TARGET_PROPERTY:gammaray_probe,LINK_LIBRARIES> Qt5::Test)
  add_test(NAME ${_name} COMMAND ${_name})
endfunction()

### BENCH SUITE

if(Qt5Widgets_FOUND)
  add_executable(benchsuite benchsuite.cpp)
  gammaray_set_rpath(benchsuite ${BIN_INSTALL_DIR})

  target_link_libraries(benchsuite
    Qt5::Core
    Qt5::Gui Qt5::Widgets
    Qt5::Test
    gammaray_common
    gammaray_core
  )

#
# Full-scale injection tests
#
  add_executable(connectiontest test_connections.cpp)
  gammaray_set_rpath(connectiontest ${BIN_INSTALL_DIR})

  target_link_libraries(connectiontest
    Qt5::Core
    Qt5::Gui Qt5::Widgets
    Qt5::Test
  )

endif()

add_executable(attachhelper attachhelper.cpp)
gammaray_set_rpath(attachhelper ${BIN_INSTALL_DIR})

target_link_libraries(attachhelper Qt5::Core)

if(UNIX)
  find_program(GDB_EXECUTABLE gdb)
  find_program(LLDB_EXECUTABLE lldb)
endif()

set(INJECTOR_TYPES)
if(UNIX)
  list(APPEND INJECTOR_TYPES preload style)

  if(GDB_EXECUTABLE)
    list(APPEND INJECTOR_TYPES gdb)
  endif()
  if(LLDB_EXECUTABLE)
    list(APPEND INJECTOR_TYPES lldb)
  endif()
elseif(WIN32)
  list(APPEND INJECTOR_TYPES windll style)
endif()

foreach(injectorType ${INJECTOR_TYPES})
  add_test(connectiontest-${injectorType}
    ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray --inprocess --listen tcp://127.0.0.1 -unittest -i ${injectorType}
    ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
  )
  add_test(connectiontest-${injectorType}-filter
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/gammaray --inprocess -unittest --listen tcp://127.0.0.1 -filtertest -i ${injectorType}
      ${PROJECT_BINARY_DIR}/${BIN_INSTALL_DIR}/connectiontest
  )
  set_tests_properties(connectiontest-${injectorType}-filter PROPERTIES ENVIRONMENT GAMMARAY_TEST_FILTER=1)
endforeach()

#
# common and core unit tests
#
gammaray_add_test(multisignalmappertest multisignalmappertest.cpp ../core/multisignalmapper.cpp)
target_link_libraries(multisignalmappertest Qt5::Gui)

gammaray_add_test(sourcelocationtest sourcelocationtest.cpp)
target_link_libraries(sourcelocationtest Qt5::Gui gammaray_common)

gammaray_add_test(selflocatortest selflocatortest.cpp)
target_link_libraries(selflocatortest Qt5::Gui gammaray_common ${CMAKE_DL_LIBS})

gammaray_add_test(executiontest executiontest.cpp)
target_link_libraries(executiontest Qt5::Gui gammaray_core)

gammaray_add_test(metaobjecttest metaobjecttest.cpp)
target_link_libraries(metaobjecttest gammaray_core)

gammaray_add_probe_test(problemreportertest problemreportertest.cpp $<TARGET_OBJECTS:modeltestobj>)
target_link_libraries(problemreportertest gammaray_core)
if(Qt5Qml_FOUND)
    target_link_libraries(problemreportertest Qt5::Qml)
endif()
if (Qt5Widgets_FOUND)
    target_link_libraries(problemreportertest Qt5::Widgets)
endif()

gammaray_add_test(objectinstancetest objectinstancetest.cpp)
target_link_libraries(objectinstancetest gammaray_core)

gammaray_add_test(propertysyncertest propertysyncertest.cpp)
target_link_libraries(propertysyncertest gammaray_common Qt5::Gui)

gammaray_add_test(propertyadaptortest propertyadaptortest.cpp)
target_link_libraries(propertyadaptortest gammaray_core Qt5::Gui gammaray_shared_test_data)

if(HAVE_QT_WIDGETS)
  gammaray_add_test(enumpropertytest enumpropertytest.cpp)
  target_link_libraries(enumpropertytest gammaray_core Qt5::Gui Qt5::Widgets)
endif()

gammaray_add_probe_test(propertymodeltest propertymodeltest.cpp $<TARGET_OBJECTS:modeltestobj>)
target_link_libraries(propertymodeltest gammaray_core gammaray_shared_test_data)

gammaray_add_test(qmetaobjectvalidatortest qmetaobjectvalidatortest.cpp)
target_include_directories(qmetaobjectvalidatortest SYSTEM PRIVATE ${Qt5Core_PRIVATE_INCLUDE_DIRS})
target_link_libraries(qmetaobjectvalidatortest Qt5::Gui gammaray_core)

if(GAMMARAY_BUILD_UI)
  gammaray_add_test(metatypemodeltest
    metatypemodeltest.cpp
    ${CMAKE_SOURCE_DIR}/core/tools/metatypebrowser/metatypesmodel.cpp
    ${CMAKE_SOURCE_DIR}/ui/tools/metatypebrowser/metatypesclientmodel.cpp
    $<TARGET_OBJECTS:modeltestobj>
  )
  target_link_libraries(metatypemodeltest gammaray_core Qt5::Gui Qt5::Widgets)
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
  gammaray_add_probe_test(signalspycallbacktest signalspycallbacktest.cpp)
  target_link_libraries(signalspycallbacktest gammaray_core)
  gammaray_add_probe_test(integrationtest integrationtest.cpp)
  target_link_libraries(integrationtest gammaray_core)
endif()

if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
  gammaray_add_probe_test(multithreadingtest multithreadingtest.cpp)
  target_link_libraries(multithreadingtest gammaray_core)

  if(GAMMARAY_BUILD_UI)
    gammaray_add_probe_test(methodmodeltest
      methodmodeltest.cpp
      ${CMAKE_SOURCE_DIR}/core/objectmethodmodel.cpp
      ${CMAKE_SOURCE_DIR}/core/qmetaobjectvalidator.cpp
      ${CMAKE_SOURCE_DIR}/core/metaobjectregistry.cpp
      ${CMAKE_SOURCE_DIR}/ui/tools/objectinspector/clientmethodmodel.cpp
      $<TARGET_OBJECTS:modeltestobj>
    )
    target_include_directories(methodmodeltest SYSTEM PRIVATE ${Qt5Core_PRIVATE_INCLUDE_DIRS})
    target_link_libraries(methodmodeltest gammaray_core Qt5::Gui Qt5::Widgets)
  endif()
endif()

#
# ui unit tests
#
if(GAMMARAY_BUILD_UI)
  gammaray_add_test(propertybindertest propertybindertest.cpp)
  target_link_libraries(propertybindertest gammaray_ui)

  if(NOT GAMMARAY_CLIENT_ONLY_BUILD)
    gammaray_add_probe_test(metaobjecttreemodeltest
      metaobjecttreemodeltest.cpp
      ${CMAKE_SOURCE_DIR}/ui/tools/metaobjectbrowser/metaobjecttreeclientproxymodel.cpp
      $<TARGET_OBJECTS:modeltestobj>
    )
    target_link_libraries(metaobjecttreemodeltest gammaray_core gammaray_ui Qt5::Gui)

    gammaray_add_probe_test(toolmanagertest
      toolmanagertest.cpp
      ../common/toolmanagerinterface.cpp
      $<TARGET_OBJECTS:modeltestobj>
    )
    target_link_libraries(toolmanagertest gammaray_core gammaray_ui Qt5::Network)
  endif()
endif()

#
# launcher unit tests
#
add_executable(sleep sleep.cpp)
target_link_libraries(sleep Qt5::Core)

if(NOT GAMMARAY_CLIENT_ONLY_BUILD AND NOT GAMMARAY_PROBE_ONLY_BUILD)
  gammaray_add_test(probeabitest probeabitest.cpp)
  target_link_libraries(probeabitest gammaray_launcher Qt5::Gui)

  gammaray_add_test(probeabidetectortest probeabidetectortest.cpp)
  target_link_libraries(probeabidetectortest gammaray_launcher Qt5::Gui)

  gammaray_add_test(selftesttest selftesttest.cpp)
  target_link_libraries(selftesttest gammaray_launcher gammaray_common Qt5::Gui)

  gammaray_add_test(earlyexittest earlyexittest.cpp)
  target_include_directories(earlyexittest PRIVATE ${CMAKE_BINARY_DIR}/launcher)
  target_link_libraries(earlyexittest gammaray_core gammaray_launcher)

  if(HAVE_QT_WIDGETS)
    gammaray_add_test(launchertest launchertest.cpp)
    target_include_directories(launchertest PRIVATE ${CMAKE_BINARY_DIR}/launcher)
    target_link_libraries(launchertest gammaray_core gammaray_launcher)
  endif()

  if(TARGET gammaray_client)
    gammaray_add_test(clientconnectiontest clientconnectiontest.cpp)
    target_link_libraries(clientconnectiontest gammaray_core gammaray_launcher gammaray_client)
  endif()
endif()

#
# client unit tests
#

if(NOT GAMMARAY_CLIENT_ONLY_BUILD AND NOT GAMMARAY_PROBE_ONLY_BUILD)
  add_executable(probesettingsclient probesettingsclient.cpp ${CMAKE_SOURCE_DIR}/core/probesettings.cpp)
  target_compile_definitions(probesettingsclient PRIVATE GAMMARAY_CORE_STATIC_DEFINE)
  target_include_directories(probesettingsclient PRIVATE ${CMAKE_BINARY_DIR}/core)

=== docs/manual/CMakeLists.txt ===
macro(qt5_build_doc _qdocconf_name)
  #compute the qdoc template dir from where the qt-html-templates-offline.qdocconf was found
  get_filename_component(QDOC_TEMPLATE_DIR ${QDOC_TEMPLATE} DIRECTORY)
  get_filename_component(QDOC_TEMPLATE_DIR ${QDOC_TEMPLATE_DIR} DIRECTORY)

  #compute the qdoc index dir from where the qtcore.index was found
  get_filename_component(QDOC_INDEX_DIR ${QDOC_QTCORE_INDEX} DIRECTORY)
  get_filename_component(QDOC_INDEX_DIR ${QDOC_INDEX_DIR} DIRECTORY)

  # run the attribution scanner to collect 3rdparty license information
  file(GLOB_RECURSE _qt_attributions "${CMAKE_SOURCE_DIR}/3rdparty/*/qt_attribution.json")
  add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/codecontributions.qdoc
    COMMAND ${QTATTRIBUTIONSSCANNER_EXECUTABLE}
        --output ${CMAKE_CURRENT_BINARY_DIR}/codecontributions.qdoc
        --filter QDocModule=gammaray-manual
        ${CMAKE_SOURCE_DIR}
    DEPENDS ${_qt_attributions} ${CMAKE_CURRENT_SOURCE_DIR}/${_qdocconf_name}-offline.qdocconf
  )

  # offline docs
  # run qdoc to get qhp file
  set(_qdoc_output_dir ${CMAKE_CURRENT_BINARY_DIR}/${_qdocconf_name})
  # FIXME: this should rather be taken from the qdocconf file?
  file(GLOB_RECURSE _qdoc_srcs ${CMAKE_CURRENT_SOURCE_DIR} "*.qdoc")
  file(GLOB _qdoc_imgs ${CMAKE_CURRENT_SOURCE_DIR} "images/*.png")
  list(APPEND _qdoc_srcs "${CMAKE_CURRENT_BINARY_DIR}/codecontributions.qdoc")
  add_custom_command(
    OUTPUT ${_qdoc_output_dir}/${_qdocconf_name}.qhp
    COMMAND ${CMAKE_COMMAND} -E env
        QT_INSTALL_DOCS=${QDOC_TEMPLATE_DIR}
        QT_VERSION_TAG=${GAMMARAY_PLUGIN_VERSION}
        QT_VERSION=${GAMMARAY_VERSION}
        BUILDDIR=${CMAKE_CURRENT_BINARY_DIR}
      ${QDOC_EXECUTABLE}
      --indexdir ${QDOC_INDEX_DIR}
      --outputdir ${_qdoc_output_dir}
    ${CMAKE_CURRENT_SOURCE_DIR}/${_qdocconf_name}-offline.qdocconf
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_qdocconf_name}-offline.qdocconf ${_qdoc_srcs} ${_qdoc_imgs}
  )

  # generate qch file from qhp
  add_custom_command(
    OUTPUT ${_qdoc_output_dir}/${_qdocconf_name}.qch
    COMMAND ${QHELPGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/${_qdocconf_name}/${_qdocconf_name}.qhp
    DEPENDS ${_qdoc_output_dir}/${_qdocconf_name}.qhp
  )
  add_custom_target(${_qdocconf_name}.qch ALL DEPENDS ${_qdoc_output_dir}/${_qdocconf_name}.qch)

  # install qch
  install(FILES ${_qdoc_output_dir}/${_qdocconf_name}.qch DESTINATION ${QCH_INSTALL_DIR})

  # online docs
  file(GLOB _qdoc_styles ${CMAKE_CURRENT_SOURCE_DIR} "style/*")
  # Qt style
  set(_qdoc_output_dir ${CMAKE_CURRENT_BINARY_DIR}/${_qdocconf_name}-online)
  add_custom_command(
    OUTPUT ${_qdoc_output_dir}/index.html
    COMMAND ${CMAKE_COMMAND} -E env
        QT_INSTALL_DOCS=${QDOC_TEMPLATE_DIR}
        QT_VERSION_TAG=${GAMMARAY_PLUGIN_VERSION}
        QT_VERSION=${GAMMARAY_VERSION}
        BUILDDIR=${CMAKE_CURRENT_BINARY_DIR}
      ${QDOC_EXECUTABLE}
      --indexdir ${QDOC_INDEX_DIR}
      --outputdir ${_qdoc_output_dir}
    ${CMAKE_CURRENT_SOURCE_DIR}/${_qdocconf_name}-online.qdocconf
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_qdocconf_name}-online.qdocconf ${_qdoc_srcs} ${_qdoc_imgs} ${_qdoc_styles}
  )
  add_custom_target(online-docs DEPENDS ${_qdoc_output_dir}/index.html)
  # KDAB style
  set(_qdoc_output_dir ${CMAKE_CURRENT_BINARY_DIR}/${_qdocconf_name}-online-kdab)
  add_custom_command(
    OUTPUT ${_qdoc_output_dir}/index.html
    COMMAND ${CMAKE_COMMAND} -E env
        QT_INSTALL_DOCS=${QDOC_TEMPLATE_DIR}
        QT_VERSION_TAG=${GAMMARAY_PLUGIN_VERSION}
        QT_VERSION=${GAMMARAY_VERSION}
        BUILDDIR=${CMAKE_CURRENT_BINARY_DIR}
      ${QDOC_EXECUTABLE}
      --indexdir ${QDOC_INDEX_DIR}
      --outputdir ${_qdoc_output_dir}
    ${CMAKE_CURRENT_SOURCE_DIR}/${_qdocconf_name}-online-kdab.qdocconf
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/${_qdocconf_name}-online-kdab.qdocconf ${_qdoc_srcs} ${_qdoc_imgs} ${_qdoc_styles}
  )
  add_custom_target(online-docs-kdab DEPENDS ${_qdoc_output_dir}/index.html)

endmacro()

qt5_build_doc(gammaray-manual)

=== plugins/bluetooth/CMakeLists.txt ===
# probe plugin
if (NOT GAMMARAY_CLIENT_ONLY_BUILD)
gammaray_add_plugin(gammaray_bluetooth JSON gammaray_bluetooth.json SOURCES bluetooth.cpp)
target_link_libraries(gammaray_bluetooth gammaray_core Qt5::Bluetooth)
endif()

=== plugins/codecbrowser/CMakeLists.txt ===
# probe part
if (NOT GAMMARAY_CLIENT_ONLY_BUILD)
set(gammaray_codecbrowser_plugin_srcs
  codecbrowser.cpp
  codecmodel.cpp
)

gammaray_add_plugin(gammaray_codecbrowser_plugin
  JSON gammaray_codecbrowser.json
  SOURCES ${gammaray_codecbrowser_plugin_srcs}
)

target_link_libraries(gammaray_codecbrowser_plugin
  gammaray_core
)
endif()

# ui part
if(GAMMARAY_BUILD_UI)

  set(gammaray_codecbrowser_plugin_ui_srcs
    codecbrowserwidget.cpp
  )

  gammaray_add_plugin(gammaray_codecbrowser_ui_plugin
    JSON gammaray_codecbrowser.json
    SOURCES ${gammaray_codecbrowser_plugin_ui_srcs}
  )

  target_link_libraries(gammaray_codecbrowser_ui_plugin
    gammaray_common
    gammaray_ui
  )

endif()

=== plugins/kjobtracker/CMakeLists.txt ===
find_package(KF5CoreAddons NO_MODULE QUIET)
set_package_properties(KF5CoreAddons PROPERTIES
  TYPE OPTIONAL
  DESCRIPTION "KDE KCoreAddons Framework"
  URL "https://www.kde.org/"
  PURPOSE "Required for the KJob tracker plug-in."
)

# probe part
if (NOT GAMMARAY_CLIENT_ONLY_BUILD)
if(KF5CoreAddons_FOUND)
  set(gammaray_kjob_plugin_srcs
    kjobtracker.cpp
    kjobmodel.cpp
  )

  gammaray_add_plugin(gammaray_kjobtracker_plugin
    JSON gammaray_kjobtracker.json
    SOURCES ${gammaray_kjob_plugin_srcs}
  )

  target_link_libraries(gammaray_kjobtracker_plugin
      gammaray_core
      KF5::CoreAddons
      Qt5::Gui
  )
endif()
endif()

# ui part
if(GAMMARAY_BUILD_UI)
  set(gammaray_kjob_ui_plugin_srcs
    kjobtrackerwidget.cpp
  )

  gammaray_add_plugin(gammaray_kjobtracker_ui_plugin
    JSON gammaray_kjobtracker.json
    SOURCES ${gammaray_kjob_ui_plugin_srcs}
  )

  target_link_libraries(gammaray_kjobtracker_ui_plugin
    gammaray_ui
  )
endif()

=== debian/changelog ===
gammaray (2.11.0-2ubuntu1) focal; urgency=medium

  * Disable LauncherTest and ClientConnectionTest that fail on Ubuntu because
    of ptrace protection.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sat, 11 Apr 2020 12:38:21 +0300

gammaray (2.11.0-2) unstable; urgency=medium

  * Team upload.
  * Ignore tests results on s390x (closes: #949903). They are currently
    failing because of QTBUG-56975, on big endian systems green and blue
    colors are swapped.
  * Make the tests results fatal on amd64, arm64, i386 and ppc64el.

 -- Dmitry Shachnev <mitya57@debian.org>  Sun, 16 Feb 2020 00:35:00 +0300

gammaray (2.11.0-1) unstable; urgency=medium

  * Team upload.
  * Acknowledge NMU, thanks Yanhao Mo!
  * New upstream release (closes: #909927).
  * Update Vcs fields to reflect qt-extras → extras move.
  * Refresh debian-archs-fix-build.patch.
  * Fix mkspecs installation path (qt-system-paths.patch).
  * Update debian/copyright.
  * Simplify debian/rules by using the default build directory.
  * Stop setting GAMMARAY_BUILD_DOCS=false, to get the manpage built.
  * Build-depend on qtlocation5-dev to enable positioning_ui plugin.
  * Add runtime QML dependencies for the positioning_ui plugin.
  * Build-depend on glslang-tools to enable GL shader code validation.
  * Remove debian/gammaray-probe-qt4.*, this package is no longer built.
  * Update to debhelper compat level 12.
  * Drop libvtk6-qt-dev build-dependency. Upstream has ported to VTK7 but
    according to them the objectvisualizer_ui plugin is “just for toying
    around, highly experimental”.
  * Install more files reported by dh_missing.
  * Update Homepage URL.
  * Build-depend on qtwebengine5-dev only on architectures where it is
    available.
  * Bump Standards-Version to 4.4.0, no changes needed.

 -- Dmitry Shachnev <mitya57@debian.org>  Tue, 27 Aug 2019 22:01:03 +0300

=== debian/control ===
Source: gammaray
Priority: optional
Section: devel
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Jakub Adam <jakub.adam@ktknet.cz>
Build-Depends: cmake,
               debhelper-compat (= 12),
               gdb,
               glslang-tools,
               libgraphviz-dev,
               libkf5coreaddons-dev,
               libkf5syntaxhighlighting-dev,
               libproj-dev,
               libqt5svg5-dev,
               libqt5waylandcompositor5-dev,
               libwayland-dev (>= 1.12.0),
               qml-module-qtquick2,
               qt3d-assimpsceneimport-plugin,
               qt3d-defaultgeometryloader-plugin,
               qt3d-gltfsceneio-plugin,
               qt3d-scene2d-plugin,
               qt3d5-dev,
               qtbase5-private-dev,
               qtconnectivity5-dev,
               qtdeclarative5-dev,
               qtdeclarative5-dev-tools,
               qtdeclarative5-private-dev,
               qtlocation5-dev,
               qtpositioning5-dev,
               qtscript5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               qttranslations5-l10n,
               qtwayland5,
               qtwebengine5-dev [amd64 arm64 armhf i386 mipsel],
               xauth,
               xvfb
Standards-Version: 4.4.0
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/gammaray.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/gammaray
Homepage: https://www.kdab.com/development-resources/qt-tools/gammaray/

Package: gammaray
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: qml-module-qt3d,
         qml-module-qtquick-controls,
         qml-module-qtquick-scene3d,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: gdb
Description: Tool for examining the internals of Qt application
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.

Package: gammaray-plugin-quickinspector
Architecture: any
Depends: gammaray (= ${binary:Version}),
         qml-module-qtquick-controls,
         qml-module-qtquick2,
         ${misc:Depends},
         ${shlibs:Depends}
Enhances: gammaray
Description: GammaRay plugin for inspecting QtQuick2 applications
 This plugin provides the user with the following inspection and debugging
 facilities:
 .
  * Tree view of all QQuickItems in the scene, marking invisible items
    and items having focus.
  * Object inspector allowing to see all the properties, inspect
    signal-slot connections, and directly invoke slots and Q_INVOKABLE
    methods.
  * Live-preview of the QtQuick scene inside the GammaRay window.
  * Qt Quick scene graph inspector.

Package: gammaray-plugin-waylandinspector
Architecture: any
Depends: gammaray (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: gammaray
Description: Wayland compositor inspector plugin for GammaRay
 The Wayland compositor inspector allows one to browse QWaylandClient
 instances and their associated resources, as well as observe Wayland
 events.

Package: gammaray-plugin-kjobtracker
Architecture: any
Depends: gammaray (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: gammaray
Description: KJob tracker plugin for GammaRay
 This plugin can be used to monitor KJob instances within a KDE-based
 application.

Package: gammaray-plugin-bluetooth
Architecture: any
Depends: gammaray (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Enhances: gammaray
Description: QtBluetooth type support for GammaRay
 This plugin adds support for QtBluetooth types into GammaRay.

Package: gammaray-plugin-positioning
Architecture: any
Depends: gammaray (= ${binary:Version}),
         qml-module-qtlocation,
         qml-module-qtpositioning,
         qml-module-qtquick2,
         ${misc:Depends},
         ${shlibs:Depends}
Enhances: gammaray
Description: Qt5Positioning type support for GammaRay
 This plugin adds support for Qt5Positioning types into GammaRay.

Package: gammaray-dev
Architecture: any
Section: libdevel
Depends: gammaray (= ${binary:Version}), ${misc:Depends}
Description: GammaRay plugin development files
 GammaRay is a tool for examining the internals of a Qt application and
 to some extent also manipulate it. GammaRay uses injection methods to
 hook into an application at runtime and provide access to a wide variety
 of interesting information. It provides easy ways of navigating through
 the complex internal structures you find in some Qt frameworks, such as
 QGraphicsView, model/view, QTextDocument, state machines and more.
 .
 This package contains header files used for building 3rd party GammaRay
 plugins.

=== debian/rules ===
#!/usr/bin/make -f

.PHONY: override_dh_auto_configure override_dh_auto_test override_dh_auto_install override_dh_installdocs

export DEB_LDFLAGS_MAINT_APPEND=-Wl,--as-needed
export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export QT_SELECT=5

# Give the build more time to finish the test suite.
# Timeouts have been appearing on buildd machines for some architectures.
export GAMMARAY_LAUNCHER_TIMEOUT=240

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_RPATH_USE_LINK_PATH=FALSE

override_dh_auto_test:
ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 i386 ppc64el))
	xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -- ARGS="-V"
# attachtest-gdb is unstable on s390x and hangs builds
else ifeq ($(DEB_HOST_ARCH), s390x)
	-xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -- ARGS="-V -E attachtest-gdb"
else
	-xvfb-run -a -s "-screen 0 640x480x24" dh_auto_test --max-parallel=1 -- ARGS="-V"
endif

override_dh_auto_install:
	dh_auto_install
	rm -f debian/tmp/usr/share/doc/gammaray/LICENSE.*

override_dh_installdocs:
	dh_installdocs --link-doc=gammaray
